print('|cFFFF0000' .. 'WoWDuel' .. '|cFFFFFF00' .. '.com ' .. '|cFF00FF00' .. 'Let the duels begin!')
CancelDuel()

-- GENERAL
local addon = LibStub('AceAddon-3.0'):NewAddon('WoWDuel', 'AceConsole-3.0')
local icon = LibStub('LibDBIcon-1.0')
local on = 'Interface\\Icons\\Ability_dualwield'
local off = 'Interface\\Icons\\Ability_stealth'
local duel_request = 'Rated duel request'
local duel_response = 'Rated duel time: '
local duel_starting = false
local duel_finished = false
local wowduel = true
local combat = ''
local buffs = ''

-- ICON
local WoWDuelLDB = LibStub('LibDataBroker-1.1'):NewDataObject('WoWDuel!', {
	type = 'data source',
	text = 'WoWDuel',
	icon = on,
	OnTooltipShow = function(tooltip) tooltip:AddLine('WoWDuel') end,
	OnClick = function() toggleRatedDuel() end,
})

-- CHARACTER
function initChar()
	if player == nil then player = '' end 
	if duels == nil then duels = ''	end
	character = UnitName('player') .. '-' .. GetRealmName()
	if UnitSex('player') == 2 then gender = 'Male' end
	if UnitSex('player') == 3 then gender = 'Female' end
	player = character .. ',' .. gender .. ',' .. UnitRace('player') .. ',' .. UnitClass('player') .. ','.. UnitLevel('player')
end

-- RESTRICTION ENGLISH
if (GetLocale() == 'enUS') then
	language_en = true
else
	print('|cFFFFFF00' .. 'Set your language to ' .. '|cFF00FF00' .. 'english' .. '|cFFFFFF00' .. ' to use ' .. '|cFFFF0000' .. 'WoWDuel')
end

-- RESTRICTION LEVEL 60
if (UnitLevel('player') == 60) then
	level_60 = true
else
	print('|cFFFFFF00' .. 'Be ' .. '|cFF00FF00' .. 'level 60' .. '|cFFFFFF00' .. ' to use ' .. '|cFFFF0000' .. 'WoWDuel')
end

-- LOAD ICON/CHARACTER
function addon:OnInitialize()
	if (level_60 == true and language_en == true) then
		self.db = LibStub('AceDB-3.0'):New('WoWDuel', {
			profile = {
				minimap = {
					hide = false,
				},
			},
		})
		icon:Register('WoWDuel!', WoWDuelLDB, self.db.profile.minimap)
		initChar()
	end
end

-- ICON TOGGLE
function toggleRatedDuel()
	CancelDuel()
	if (WoWDuelLDB.icon == on) then
		print('|cFFFF0000' .. 'WoWDuel' .. '|cFFFFFF00' .. ' turned ' .. '|cFFFF0000' .. 'Off')
		WoWDuelLDB.icon = off
		wowduel = false
	else
		print('|cFFFF0000' .. 'WoWDuel' .. '|cFFFFFF00' .. ' turned ' .. '|cFF00FF00' .. 'On')
		WoWDuelLDB.icon = on
		wowduel = true
	end
end

-- CHARACTER BUFFS
function Buffs()
	for i=1,20 do
		local name, icon, a, b, c, d, e, f, g, spellId = UnitBuff('player', i)
		typus = 'BUFF'
		if (spellId ~= '') then
			buff = duel_time .. '-' .. spellId .. '-' .. 0 .. '-' .. typus .. '-' .. UnitHealth('player') .. '-'.. UnitPower('player')
			buffs = buffs .. buff .. '_'
		end
	end
end

-- RATED DUEL STARTING 1
local s1 = CreateFrame('Frame')
s1:RegisterEvent('DUEL_REQUESTED')
s1:SetScript('OnEvent', function(self, event, ...)
	if (wowduel == true) then
		duel_requester = select(1, ...)
		SendChatMessage(duel_request, 'WHISPER', 'Common' , duel_requester)
	end
end)

-- RATED DUEL STARTING 2
local s2 = CreateFrame('Frame')
s2:RegisterEvent('CHAT_MSG_WHISPER')
s2:SetScript('OnEvent', function(self, event, message, sender, ...)
	if (wowduel == true and strmatch(message, duel_request)) then
		opponent = sender
		duel_time = time()
		duel_starting = true
		print('|cFF00FF00' .. character .. '|cFFFFFF00' .. ' vs ' .. '|cFFFF0000' .. opponent)
		SendChatMessage(duel_response .. duel_time, 'WHISPER', 'Common' , opponent)
		Buffs()
	end
end)

-- RATED DUEL STARTING 3
local s3 = CreateFrame('Frame')
s3:RegisterEvent('CHAT_MSG_WHISPER')
s3:SetScript('OnEvent', function(self, event, message, sender, ...)	
	if (wowduel == true and strmatch(message, duel_response)) then
		opponent = sender
		duel_time = message:match(duel_response .. '(.+)')
		duel_starting = true
		print('|cFF00FF00' .. character .. '|cFFFFFF00' .. ' vs ' .. '|cFFFF0000' .. opponent)
		Buffs()
	end
end)

-- RATED DUEL STARTING 4
local s4 = CreateFrame('Frame')
s4:RegisterEvent('CHAT_MSG_SYSTEM')
s4:SetScript('OnEvent', function(self, event, ...)
	duel_start_1 = select(1, ...)
	if (wowduel == true and strmatch(duel_start_1, ': 1')) then
		duel_leave = duel_time .. ',' .. duel_time .. ',' .. opponent .. ',' .. character .. ',' .. buffs:sub(1, -2) .. ';'
		duel_leave_len = string.len(duel_leave) + 1
		duels = duels .. duel_leave
	end
end)

-- RATED DUEL COMBAT LOG
local c = CreateFrame('Frame')
c:RegisterEvent('COMBAT_LOG_EVENT_UNFILTERED')
c:SetScript('OnEvent', function(self, event)self:OnEvent(event, CombatLogGetCurrentEventInfo()) end)
function c:OnEvent(event, ...)
	if (duel_starting == true) then
		local timestamp, subevent, _, sourceGUID, sourceName, sourceFlags, sourceRaidFlags, destGUID, destName, destFlags, destRaidFlags = ...
		local amount, overkill, school, resisted, blocked, absorbed, critical, glancing, crushing, isOffHand
		local spellId, spellName, spellSchool
		if subevent == 'SWING_DAMAGE' then
			typus = 'DMG'
			amount = select(12, ...)
			spellId = 0	
		elseif subevent == 'RANGE_DAMAGE' then
			typus = 'DMG'
			spellId, spellName, spellSchool, amount, overkill, school, resisted, blocked, absorbed, critical, glancing, crushing, isOffHand = select(12, ...)
		elseif subevent == 'SPELL_DAMAGE' then
			typus = 'DMG'
			spellId, spellName, spellSchool, amount, overkill, school, resisted, blocked, absorbed, critical, glancing, crushing, isOffHand = select(12, ...)
		elseif subevent == 'SPELL_HEAL' then
			typus = 'HEAL'
			spellId, spellName, spellSchool, amount, overkill, school, resisted, blocked, absorbed, critical, glancing, crushing, isOffHand = select(12, ...)
		elseif subevent == 'SPELL_DRAIN' then
			typus = 'DMG'
			spellId, spellName, spellSchool, amount, overkill, school, resisted, blocked, absorbed, critical, glancing, crushing, isOffHand = select(12, ...)
		elseif subevent == 'SPELL_LEECH' then
			typus = 'HEAL'
			spellId, spellName, spellSchool, amount, overkill, school, resisted, blocked, absorbed, critical, glancing, crushing, isOffHand = select(12, ...)
		elseif subevent == 'SPELL_PERIODIC_DAMAGE' then
			typus = 'DMG'
			spellId, spellName, spellSchool, amount, overkill, school, resisted, blocked, absorbed, critical, glancing, crushing, isOffHand = select(12, ...)
		elseif subevent == 'SPELL_PERIODIC_HEAL' then
			typus = 'HEAL'
			spellId, spellName, spellSchool, amount, overkill, school, resisted, blocked, absorbed, critical, glancing, crushing, isOffHand = select(12, ...)
		elseif subevent == 'SPELL_PERIODIC_DRAIN' then
			typus = 'DMG'
			spellId, spellName, spellSchool, amount, overkill, school, resisted, blocked, absorbed, critical, glancing, crushing, isOffHand = select(12, ...)
		elseif subevent == 'SPELL_PERIODIC_LEECH' then
			typus = 'HEAL'
			spellId, spellName, spellSchool, amount, overkill, school, resisted, blocked, absorbed, critical, glancing, crushing, isOffHand = select(12, ...)
		end
		if (spellId ~= '' and destGUID == UnitGUID('player')) then
			if ((typus == 'DMG' or typus == 'HEAL') and amount > 0) then
				spell = GetServerTime() .. '-' .. spellId .. '-' .. amount .. '-' .. typus .. '-' .. UnitHealth('player') .. '-'.. UnitPower('player') .. '_'
				combat = combat .. spell
			end
		end
	end
end

-- SPLIT
function Split(s, delimiter)
	result = {}
	for match in (s..delimiter):gmatch('(.-)'..delimiter) do
		table.insert(result, match)
	end
	return result
end

-- RATED DUEL FINISHED
local f = CreateFrame('Frame')
f:RegisterEvent('CHAT_MSG_SYSTEM')
f:SetScript('OnEvent', function(self, event, ...)
	if (duel_starting == true) then
		var = select(1, ...)
		enemy = Split(opponent, '-')
		a = string.find(var, UnitName('player') .. ' ')
		b = string.find(var, enemy[1])
		if (strmatch(var,'has defeated')) then
			duel_finished = true
			if (a < b) then
				winner = character
				loser = opponent
			else
				winner = opponent
				loser = character
			end
		elseif (strmatch(var,'has fled from')) then
			duel_finished = true
			if (a > b) then
				winner = character
				loser = opponent
			else
				winner = opponent
				loser = character
			end
		end
		if(duel_finished == true) then
			screenshot = time()
			Screenshot()
			if (duels == nil) then duels = '' end
			if (combat == '') then combat = ',' end
			duellers = winner .. ',' .. loser
			duel = duel_time .. ',' .. screenshot .. ',' .. duellers .. ',' .. buffs .. combat
			duel = duel:sub(1, -2) .. ';'
			duels = duels:sub(1, -duel_leave_len)
			duels = duels .. duel
			duel_starting = false
			duel_finished = false
			print('|cFF00FF00' .. 'Good duel')
			print('|cFFFFFF00' .. 'Type ' .. '|cFF00FF00' .. '/reload' .. '|cFFFFFF00' .. ' to save your duels')
			SendChatMessage('Rated duel saved', 'WHISPER', 'Common' , opponent)
		end
	end
end)
